package org.objectweb.telosys.screen.core;

import java.util.Map;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.dal.dao.DatabaseSession;
import org.objectweb.telosys.rpl.ScreenRequest;
import org.objectweb.telosys.rpl.ScreenRequestParameters;
import org.objectweb.telosys.rpl.ScreenResponse;
import org.objectweb.telosys.screen.env.ScreenSession;

/**
 * @author Laurent GUERIN
 *  
 */
public interface ScreenManager
{
    public DatabaseSession getDatabaseSession() throws TelosysException;
    
    //--- New method ( v 0.9.7 )
    public void doInit(ScreenData screenData, ScreenContext screenContext, Map param, DatabaseSession dbSession) throws TelosysException ;

    //--- New methods ( v 0.9.5 )
    public void doLoad(ScreenData screenData, ScreenContext screenContext, ScreenRequest request, ScreenResponse response, DatabaseSession session) throws TelosysException;

    public void doSave(ScreenData screenData, ScreenContext screenContext, ScreenRequest request, ScreenResponse response, DatabaseSession session) throws TelosysException;

    public void doInsert(ScreenData screenData, ScreenContext screenContext, ScreenRequest request, ScreenResponse response, DatabaseSession session) throws TelosysException;

    public void doUpdate(ScreenData screenData, ScreenContext screenContext, ScreenRequest request, ScreenResponse response, DatabaseSession session) throws TelosysException;

    public void doDelete(ScreenData screenData, ScreenContext screenContext, ScreenRequest request, ScreenResponse response, DatabaseSession session) throws TelosysException;
    
    
    //--- New method ( v 0.9.9 )
    public void eventCreate(ScreenContext screenContext, ScreenRequestParameters params, ScreenSession screenSession ) throws TelosysException ;

    //--- New method ( v 0.9.9 )
    public void eventReuse(ScreenContext screenContext, ScreenRequestParameters params, ScreenSession screenSession ) throws TelosysException ;
    
}