package org.objectweb.telosys.uil.taglib.util;

import java.util.Iterator;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.Finder;
import org.objectweb.telosys.uil.taglib.LoopManager;
import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.util.StrUtil;

/**
 * @author Laurent GUERIN
 *  
 */
public class Iterate extends CommonTagSupport 
{
    //----------------------------------------------------------------
    // Private variables
    //----------------------------------------------------------------
//    private int      _iCount   = 0;
//
//    private int      _iIndex   = 0;
//
//    private Iterator _iterator = null;

    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String   _sList    = null;

    private String   _sScope   = null;

    private String   _sIndexbase = null;

    //----------------------------------------------------------------
    public void setList(String v)
    {
        this._sList = v;
    }

    //----------------------------------------------------------------
    public void setScope(String v)
    {
        this._sScope = v;
    }

    //----------------------------------------------------------------
    public void setIndexbase(String v)
    {
        this._sIndexbase = v;
    }

    //----------------------------------------------------------------
//    private Iterator getIterator()
//    {
//        if (_sList == null)
//        {
//            tagLibMessage("No list attribute : cannot get iterator ");
//            return null;
//        }
//        else
//        {
//            Object oList = Finder.findObject(pageContext, _sList, _sScope);
//            if (oList != null)
//            {
//                if (oList instanceof GenericVOList)
//                {
//                    return ((GenericVOList) oList).iterator();
//                }
//                else if (oList instanceof DataSet)
//                {
//                    return ((DataSet) oList).iterator();
//                }
//                else if (oList instanceof Collection) 
//                {
//                    return ((Collection) oList).iterator();
//                }
//                else
//                {
//                    tagLibMessage("Invalid list type : class = " + oList.getClass().getName());
//                }
//            }
//            else
//            {
//                tagLibMessage("List attribute '" + _sList + "' not found");
//            }
//        }
//        return null;
//    }

    /**
     * Get the next item and set it in the page context
     * 
     * @return true if there's a next item, else false
     */
//    private boolean nextItem()
//    {
//        if (_iterator != null)
//        {
//            if (_iterator.hasNext())
//            {
//                _iCount++; // 1 to N
//                Page.setIterationCount(pageContext, _iCount);
//                Page.setIterationIndex(pageContext, _iIndex);
//                //Page.setCurrentBean(pageContext, _iterator.next()); // v 0.9.9
//                CurrentBean.setBean(pageContext, _iterator.next()); // v 0.9.9
//                _iIndex++; // 0 to N
//                return true;
//            }
//        }
//        return false;
//    }

    //----------------------------------------------------------------
    //----------------------------------------------------------------
    public int doStartTag()
    {
        // v 0.9.9 : use LoopManager
        Page.setLoopManager(pageContext, null); // if NULL => remove 
        if (_sList != null)
        {
            Iterator iter = Finder.findIterator(pageContext, _sList, _sScope);
            //--- Init a loop manager ( with the ITERATOR )
            if ( iter != null )
            {
                int iIndexBase = 0 ;
                if ( _sIndexbase != null )
                {
                    iIndexBase = StrUtil.getInt(_sIndexbase, 0);
                }
                LoopManager loopManager = new LoopManager ( pageContext, iter, iIndexBase );   
                //--- Set the loop manager in the current page context
                Page.setLoopManager(pageContext, loopManager);
                if ( loopManager.first() )
                {
                    return EVAL_BODY_INCLUDE;
                }
            }
            else                
            {
                tagLibMessage("ITERATE : Cannot find iterator ");
            }
        }
        else
        {
            tagLibMessage("ITERATE : No list attribute");
        }
        
        return SKIP_BODY;        
        
        /*** v 0.9.9
        _iCount = 0;
        _iIndex = 0;
        _iterator = getIterator();
        if (nextItem())
        {
            return EVAL_BODY_INCLUDE;
        }
        return SKIP_BODY;
        ***/
    }

    //----------------------------------------------------------------
    public int doAfterBody()
    {
        // v 0.9.9 : use LoopManager
        //--- Retrieve the LOOP MANAGER
        LoopManager loopManager = Page.getLoopManager(pageContext) ;   
        //--- If there's a NEXT ITEM in the loop
        if ( loopManager != null )
        {
            if ( loopManager.next() )
            {
                //--- Another iteration ...
                return EVAL_BODY_AGAIN;
            }
        }

        //--- It's the end ( no other iteration ) 
        return SKIP_BODY;                       
        
        /*** v 0.9.9
        if (nextItem())
        {
            return EVAL_BODY_AGAIN;
        }
        return SKIP_BODY;
        ***/
    }
    //----------------------------------------------------------------
}