package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;

import org.objectweb.telosys.uil.taglib.ListDiv;
import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.TagConst;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.ListBody;

/**
 * Widget HTML generator
 * 
 * @author Laurent GUERIN
 *  
 */
public class ListBodyHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        //System.out.println("LisyBodyHTML - startTag ");
        ListBody tag = (ListBody) genericTag;
        PageContext pageContext = tag.getPageContext();
        //System.out.println("LisyBodyHTML - setListBody TRUE ");
        Page.setListBody(pageContext, true);

        //--- ID and WIDTH 
        String sId = tag.getId() ;
        int iWidth = tag.getWidthInt() ; 
        ListDiv listDiv = Page.getListDiv(tag.getPageContext());
        if ( listDiv != null )
        {
            if ( sId == null ) 
            {
                //--- No id for this tag => use the default id
                sId = listDiv.getIdBody() ;                
            }
            else
            {
                //--- id is set for this tag => keep it for the future
                listDiv.setIdBody(sId);
            }
            if ( iWidth == TagConst.WIDTH_NULL )
            {
                iWidth = listDiv.getWidthBody();                
            }
        }
        //--- HEAD ID
        String sIdHead = listDiv.getIdHead() ;

        //--- HEIGHT 
        int iHeight = tag.getHeightInt() ;
        //System.out.println("LisyBodyHTML - iHeight = " + iHeight + " (" + tag.getHeight() +")");
        
        String sStyle = getStyleFragUserStyle(tag) + getStyleFragWidth(iWidth) + getStyleFragHeight(iHeight) + "overflow: auto;";
        
        //--- Tag <div ... >
        out.print("<div "
                + getIdAttr(sId) + " "
                + getClassAttr(tag, "telosys_list_body") + " "
                + getStyleAttr(sStyle) + " " 
                + "onscroll=\"fwkScrollHead('" + sIdHead + "',this)\" "
                + ">");

        //--- Tags <table ... > + <tbody> 
        out.print("<table cellspacing=\"0\" style=\"table-layout:fixed; width:1%; \" >");
        out.print("<tbody>");        
        out.println("");        
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        //System.out.println("LisyBodyHTML - endTag ");

        //--- Close all tags
        out.print("</tbody>");
        out.print("</table>");
        out.print("</div>");        
        out.println("");
        
        PageContext pageContext = genericTag.getPageContext();
        Page.setListBody(pageContext, false); // Not in BODY
        
        //System.out.println("LisyBodyHTML - setListBody FALSE ");
        
    }
    //----------------------------------------------------------------
}